#ifndef GRAPHIC_LED_H
#define GRAPHIC_LED_H

#include "Screen.h"

class GraphicLed:public Widget
{
public:
    /** Construct a filled Circle
        *
        * @param mScreen the pointer screen
        * @params _xc center
        * @params _yc center
        * @params _radius
        * @params _colorOn
        * @params _colorOff
        * @params _state LED_STATE_ON or LED_STATE_OFF,
        */
        
    GraphicLed(Screen* mScreen,UINT16 _xc,UINT16 _yc,UINT16 _radius,
               Color _colorOn,Color _colorOff,State _state);
    //
    virtual void draw(void);
    //
    virtual ~GraphicLed(void);


//setter
    void setInvisible(bool _state);
    //
    void setState(State _state);

protected:
    Color myColorOn;
    Color myColorOff;
    UINT16 myRadius;
    UINT16 myCenterX;
    UINT16 myCenterY;
};

#endif